﻿//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  テキストを Base64 で符号化して保存
//
//-----------------------------------------------------------------------------
//
//  【使用条件等】
//
//  当サイトのアプリケーション類，コンポーネント，コード類は，転載，改変，配布
//  (オリジナル，改変版)などは全て自由です．商用利用も自由です．連絡，使用の記
//  載義務もありません．ただしオリジナルそのものを商用とすることは禁止します．
//  なお，本サイトのプログラムやコードを使用したことによって生じた，いかなる障
//  害，損失に関しても作者は一切関与しないものとします．ご了承下さい．
//
//-----------------------------------------------------------------------------
//
//  【履歴】
//
//  2017年01月20日 ～
//
//-----------------------------------------------------------------------------
//
//  【動作確認環境】
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, IdBaseComponent, IdCoder, IdCoder3to4,
  IdCoderMIME;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Memo1: TMemo;
    IdEncoderMIME1: TIdEncoderMIME;
    IdDecoderMIME1: TIdDecoderMIME;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 宣言 }
    FFilePath : string;
  public
    { Public 宣言 }
  end;

var
  Form1: TForm1;

implementation

uses
  IdGlobal;

{$R *.dfm}

//=============================================================================
//  フォーム生成時の処理
//  FFilePath は String 型のグローバル変数
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  Memo1.Lines.Clear;

  //文字列をセット
  Memo1.Lines.Add(#$4F60#$597D + ' !!');
  Memo1.Lines.Add(#$D842#$DFB7 + ' (サロゲートペアな文字)');
  Memo1.Lines.Add('テキストを Base64 で符号化して保存');

  FFilePath := ExpandFileName('..\000.txt');
end;

//=============================================================================
//  テキストを Base64 で符号化 ( Base64 でエンコード ) して保存
//
//  Indy (Ver 10.6.2.0) の TIdEncoderMIME コンポーネントを使用する例
//  uses に IdGlobal が必要
//  TIdEncoderMIME を実行時に生成して使用する場合は uses に IdCoderMIME が必要
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LAnsiStr   : AnsiString;
  LMemStream : TMemoryStream;
begin
  LMemStream := TMemoryStream.Create;
  try
    LAnsiStr := IdEncoderMIME1.Encode(Memo1.Lines.Text, IndyTextEncoding_UTF8);

    LMemStream.Position := 0;
    LMemStream.Write(LAnsiStr[1], Length(LAnsiStr));
    LMemStream.SaveToFile(FFilePath);
  finally
    FreeAndNil(LMemStream);
  end;
end;

//=============================================================================
//  Base64 で符号化して保存したテキストを読み出して複合化 ( Base64 のデコード )
//
//  Indy (Ver 10.6.2.0) の TIdDecoderMIME コンポーネントを使用する例
//  uses に IdGlobal が必要
//  TIdDecoderMIME を実行時に生成して使用する場合は uses に IdCoderMIME が必要
//=============================================================================
procedure TForm1.Button2Click(Sender: TObject);
var
  LMemStream : TMemoryStream;
  LAnsiStr   : AnsiString;
  LUtf8Str   : UTF8String;
begin
  Memo1.Lines.Clear;

  LMemStream := TMemoryStream.Create;
  try
    LMemStream.LoadFromFile(FFilePath);

    SetLength(LAnsiStr, LMemStream.Size);
    LMemStream.Position := 0;
    LMemStream.Read(LAnsiStr[1], Length(LAnsiStr));

    LUtf8Str := IdDecoderMIME1.DecodeString(LAnsiStr, IndyTextEncoding_UTF8);

    Memo1.Lines.Text := LUtf8Str;
  finally
    FreeAndNil(LMemStream);
  end;
end;

end.
